declare type JSTypeAllow = string | boolean | number;
declare type JSTypePrimitive = JSTypeAllow | null | undefined;
declare type JSTypeObject = {
    [key: string]: JSType;
};
declare type JSType = JSTypePrimitive | JSTypeObject;
declare type DecoderTypePrimitive = string;
declare type DecoderTypeObject = {
    [key: string]: unknown;
};
declare type DecoderType = DecoderTypePrimitive | DecoderTypeObject;
declare type DecodeFnReturn<T> = (input: JSType) => T;
declare type DecodeFnType<T> = DecodeFnReturn<T> & {
    withDefault: (s: T) => DecodeFnReturn<T>;
};
declare type DecodeDecoder<decoder> = [decoder] extends [DecoderTypePrimitive] ? decoder : {
    [key in keyof decoder]: DecodeType<decoder[key]>;
};
export declare type DecodeType<decoder> = (decoder extends DecodeFnReturn<infer T> ? [DecodeType<T>] : decoder extends DecoderType ? [DecodeDecoder<decoder>] : [decoder])[0];
export declare const asString: DecodeFnType<string>;
export declare const asNumber: DecodeFnType<number>;
export declare const asBoolean: DecodeFnType<boolean>;
export declare const environmentDecoder: <S>(schemaType: S) => DecodeType<S>;
export {};
